import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
/**
 * @copyright   2017, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

import { Adapter } from 'aesthetic';
import { css } from 'glamor';

var GlamorAdapter = function (_Adapter) {
  _inherits(GlamorAdapter, _Adapter);

  function GlamorAdapter() {
    _classCallCheck(this, GlamorAdapter);

    return _possibleConstructorReturn(this, (GlamorAdapter.__proto__ || Object.getPrototypeOf(GlamorAdapter)).apply(this, arguments));
  }

  _createClass(GlamorAdapter, [{
    key: 'transform',
    value: function transform(styleName, declarations) {
      var _this2 = this;

      if ("production" !== process.env.NODE_ENV) {
        if (this.native) {
          throw new Error('Glamor does not support React Native.');
        }
      }

      var output = {};

      Object.keys(declarations).forEach(function (setName) {
        var value = declarations[setName];

        if (typeof value === 'string') {
          output[setName] = _this2.native ? {} : value;
        } else {
          output[setName] = styleName + '-' + String(css(value));
        }
      });

      return output;
    }
  }]);

  return GlamorAdapter;
}(Adapter);

export default GlamorAdapter;