import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _get from 'babel-runtime/helpers/get';
import _inherits from 'babel-runtime/helpers/inherits';
/**
 * @copyright   2017, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

import UnifiedSyntax from 'aesthetic/unified';
import { injectAtRules, injectFallbacks } from 'aesthetic-utils';
import { css } from 'glamor';
import GlamorAdapter from './NativeAdapter';

var UnifiedGlamorAdapter = function (_GlamorAdapter) {
  _inherits(UnifiedGlamorAdapter, _GlamorAdapter);

  function UnifiedGlamorAdapter() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, UnifiedGlamorAdapter);

    var _this = _possibleConstructorReturn(this, (UnifiedGlamorAdapter.__proto__ || Object.getPrototypeOf(UnifiedGlamorAdapter)).call(this, options));

    _this.onDeclaration = function (setName, properties) {
      if ('animationName' in properties) {
        properties.animationName = _this.syntax.keyframeNames[String(properties.animationName)];
      }

      if (_this.syntax.mediaQueries[setName]) {
        injectAtRules(properties, '@media', _this.syntax.mediaQueries[setName]);
      }

      if (_this.syntax.fallbacks[setName]) {
        injectFallbacks(properties, _this.syntax.fallbacks[setName]);
      }
    };

    _this.onFontFace = function (setName, familyName, properties) {
      _this.syntax.fontFaceNames[familyName] = css.fontFace(properties);
    };

    _this.onKeyframe = function (setName, animationName, properties) {
      _this.syntax.keyframeNames[animationName] = css.keyframes(animationName, properties);
    };

    _this.syntax = new UnifiedSyntax();
    _this.syntax.on('declaration', _this.onDeclaration).on('fontFace', _this.onFontFace).on('keyframe', _this.onKeyframe);
    return _this;
  }

  _createClass(UnifiedGlamorAdapter, [{
    key: 'convert',
    value: function convert(declarations) {
      return this.syntax.convert(declarations);
    }
  }, {
    key: 'transform',
    value: function transform(styleName, declarations) {
      return _get(UnifiedGlamorAdapter.prototype.__proto__ || Object.getPrototypeOf(UnifiedGlamorAdapter.prototype), 'transform', this).call(this, styleName, this.convert(declarations));
    }
  }]);

  return UnifiedGlamorAdapter;
}(GlamorAdapter);

export default UnifiedGlamorAdapter;