'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _aesthetic = require('aesthetic');

var _glamor = require('glamor');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright   2017, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

var GlamorAdapter = function (_Adapter) {
  (0, _inherits3.default)(GlamorAdapter, _Adapter);

  function GlamorAdapter() {
    (0, _classCallCheck3.default)(this, GlamorAdapter);
    return (0, _possibleConstructorReturn3.default)(this, (GlamorAdapter.__proto__ || Object.getPrototypeOf(GlamorAdapter)).apply(this, arguments));
  }

  (0, _createClass3.default)(GlamorAdapter, [{
    key: 'transform',
    value: function transform(styleName, declarations) {
      var _this2 = this;

      if ("production" !== process.env.NODE_ENV) {
        if (this.native) {
          throw new Error('Glamor does not support React Native.');
        }
      }

      var output = {};

      Object.keys(declarations).forEach(function (setName) {
        var value = declarations[setName];

        if (typeof value === 'string') {
          output[setName] = _this2.native ? {} : value;
        } else {
          output[setName] = styleName + '-' + String((0, _glamor.css)(value));
        }
      });

      return output;
    }
  }]);
  return GlamorAdapter;
}(_aesthetic.Adapter);

exports.default = GlamorAdapter;