'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _unified = require('aesthetic/unified');

var _unified2 = _interopRequireDefault(_unified);

var _aestheticUtils = require('aesthetic-utils');

var _glamor = require('glamor');

var _NativeAdapter = require('./NativeAdapter');

var _NativeAdapter2 = _interopRequireDefault(_NativeAdapter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright   2017, Miles Johnson
 * @license     https://opensource.org/licenses/MIT
 * 
 */

var UnifiedGlamorAdapter = function (_GlamorAdapter) {
  (0, _inherits3.default)(UnifiedGlamorAdapter, _GlamorAdapter);

  function UnifiedGlamorAdapter() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck3.default)(this, UnifiedGlamorAdapter);

    var _this = (0, _possibleConstructorReturn3.default)(this, (UnifiedGlamorAdapter.__proto__ || Object.getPrototypeOf(UnifiedGlamorAdapter)).call(this, options));

    _this.onDeclaration = function (setName, properties) {
      if ('animationName' in properties) {
        properties.animationName = _this.syntax.keyframeNames[String(properties.animationName)];
      }

      if (_this.syntax.mediaQueries[setName]) {
        (0, _aestheticUtils.injectAtRules)(properties, '@media', _this.syntax.mediaQueries[setName]);
      }

      if (_this.syntax.fallbacks[setName]) {
        (0, _aestheticUtils.injectFallbacks)(properties, _this.syntax.fallbacks[setName]);
      }
    };

    _this.onFontFace = function (setName, familyName, properties) {
      _this.syntax.fontFaceNames[familyName] = _glamor.css.fontFace(properties);
    };

    _this.onKeyframe = function (setName, animationName, properties) {
      _this.syntax.keyframeNames[animationName] = _glamor.css.keyframes(animationName, properties);
    };

    _this.syntax = new _unified2.default();
    _this.syntax.on('declaration', _this.onDeclaration).on('fontFace', _this.onFontFace).on('keyframe', _this.onKeyframe);
    return _this;
  }

  (0, _createClass3.default)(UnifiedGlamorAdapter, [{
    key: 'convert',
    value: function convert(declarations) {
      return this.syntax.convert(declarations);
    }
  }, {
    key: 'transform',
    value: function transform(styleName, declarations) {
      return (0, _get3.default)(UnifiedGlamorAdapter.prototype.__proto__ || Object.getPrototypeOf(UnifiedGlamorAdapter.prototype), 'transform', this).call(this, styleName, this.convert(declarations));
    }
  }]);
  return UnifiedGlamorAdapter;
}(_NativeAdapter2.default);

exports.default = UnifiedGlamorAdapter;